<?php
/*
Plugin Name: WordPress allow dashes
Plugin URI: http://rudd-o.com/projects/wp-allowdashes/
Description: Ensures WordPress allows registration of user names with dashes
Version: 0.1.1
Author: Manuel Amador (Rudd-O)
Author URI: http://rudd-o.com/
*/

/*  Copyright 2006  Manuel Amador

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* fixes a bug in WordPress 2.0 and higher, this bug eats dashes in usernames for dinner */
/* basically a reimplementation of sanitize_user */
function allowdashes($username,$raw_username,$strict) {
	$username = strip_tags($raw_username);
	// Kill octets
	$username = preg_replace('|%([a-fA-F0-9][a-fA-F0-9])|', '', $username);
	$username = preg_replace('/&.+?;/', '', $username); // Kill entities

	// If strict, reduce to ASCII for max portability.
	if ( $strict )
		$username = preg_replace('|[^a-z0-9 _.\-@]|i', '', $username); // <- take a look at the escaped dash

	return $username;
}


add_filter('sanitize_user', 'allowdashes',10,3);

?>
